package com.rjconsultores.integracaoreceitadespesa.entidades;

import java.util.List;

import org.apache.commons.lang.StringUtils;

public class DespesaReceitaComporte extends DespesaReceita {

	protected String numeroEstabelecimento;
	protected String codigoAutorizacao;
	protected String cantParcelas = "";
	protected String numfoliosistema = "";
	protected String txId = "";
	
	@Override
	public void preencheLinha(List<String> rows) {
		StringBuilder sb = new StringBuilder();
		sb.append(StringUtils.rightPad(dataLancamento.trim(), 10, " ")); //10
		sb.append(StringUtils.leftPad(codigoEmpresa.trim(), 3, "0"));   //13
		sb.append(StringUtils.leftPad(codigoFilial.trim(), 3, "0")); //16
		sb.append(StringUtils.rightPad(truncStr(localArrecadacao.toUpperCase(), 5), 5, " ")); //21
		sb.append(StringUtils.rightPad(numeroDaGuia.trim(), 25, " "));   //46
		sb.append(StringUtils.rightPad(dataMovimento.trim(), 10, " "));  //56
		sb.append(StringUtils.rightPad(usuarioGlobus.trim(), 15, " "));  //71
		sb.append(StringUtils.leftPad(turno.trim(), 2, "0")); //73
		sb.append(StringUtils.leftPad(codigoReceitaDespesa.trim(), 10, "0")); //83
		sb.append(StringUtils.rightPad(identificadorReceitaDespesa.toUpperCase().trim(), 1, "0")); //84
		sb.append(StringUtils.leftPad(valorLancamento.trim(), 13, "0")); //97
		sb.append(StringUtils.leftPad(numeroContratoTurismo.trim(), 10, "0"));
		sb.append(StringUtils.leftPad(numeroReciboTurismo.trim(), 10, "0"));
		sb.append(StringUtils.leftPad(getFormaPagamentoTurismo().trim(),2,"0"));
		sb.append(StringUtils.leftPad(getTipoPagamentoTurismo().trim(), 2, "0"));
		sb.append(StringUtils.rightPad("", 80, " "));
		sb.append(StringUtils.rightPad(StringUtils.isNotEmpty(numeroEstabelecimento)  ? StringUtils.rightPad(numeroEstabelecimento, 10, "0").substring(0,10) : "", 10, "0"));
		sb.append(StringUtils.rightPad(StringUtils.isNotEmpty(codigoAutorizacao)  ? StringUtils.rightPad(codigoAutorizacao, 25, "0").substring(0,24) : "", 25, " "));
		sb.append(StringUtils.leftPad(formaPagamentoId, 2, "0"));
		sb.append(StringUtils.isNotEmpty(cantParcelas) ? StringUtils.leftPad(cantParcelas, 4,"0") : "0000");
		sb.append(numfoliosistema);
		sb.append(txId);
		sb.append(finalLinha);
		sb.append(System.getProperty("line.separator"));
		rows.add(sb.toString());
	}

	public String getNumeroEstabelecimento() {
		return numeroEstabelecimento;
	}

	public void setNumeroEstabelecimento(String numeroEstabelecimento) {
		this.numeroEstabelecimento = StringUtils.rightPad(numeroEstabelecimento != null ? numeroEstabelecimento : " ", 10, " ");
	}

	public String getCodigoAutorizacao() {
		return codigoAutorizacao;
	}

	public void setCodigoAutorizacao(String codigoAutorizacao) {
		this.codigoAutorizacao =  StringUtils.rightPad(codigoAutorizacao != null ? truncStr(codigoAutorizacao, 25) : " ", 25, "0");
	}

	public String getCantParcelas() {
		return cantParcelas;
	}

	public void setCantParcelas(String cantParcelas) {
		this.cantParcelas = StringUtils.isNotEmpty(cantParcelas) ? StringUtils.leftPad(cantParcelas, 4,"0") : "0000";
	}

	public String getNumfoliosistema() {
		return numfoliosistema;
	}

	public void setNumfoliosistema(String numfoliosistema) {
		this.numfoliosistema = StringUtils.leftPad(numfoliosistema != null ? numfoliosistema : "", 16, " ");
	}

	public String getTxId() {
		return txId;
	}

	public void setTxId(String txId) {
		this.txId = StringUtils.leftPad(txId != null ?  truncStr(txId, 36) : "", 35, " ");
	}
		
}
